git » mk-builders.git » commit 6110ced

new scripts and stuff

author Urja (ARMLFS builder)
2024-07-12 16:26:11 UTC
committer Urja (ARMLFS builder)
2024-07-12 16:26:11 UTC
parent a0e4c1fa916865026d10718850a7e1558acd178f

new scripts and stuff

bs64-pacman.conf +80 -0
build64-initial.sh +1 -0
build64-pacman.conf +3 -3
builder-initial.sh +23 -0
make-bootstrap64.sh +21 -0
make-bootstrapper.sh +1 -3
make-builder.sh +74 -0

diff --git a/bs64-pacman.conf b/bs64-pacman.conf
new file mode 100644
index 0000000..a47bee8
--- /dev/null
+++ b/bs64-pacman.conf
@@ -0,0 +1,80 @@
+#
+# /etc/pacman.conf
+#
+# See the pacman.conf(5) manpage for option and repository directives
+
+#
+# GENERAL OPTIONS
+#
+[options]
+# The following paths are commented out with their default values listed.
+# If you wish to use different paths, uncomment and update the paths.
+#RootDir     = /
+#DBPath      = /var/lib/pacman/
+CacheDir    = /tmp/arm64-pkg
+#LogFile     = /var/log/pacman.log
+#GPGDir      = /etc/pacman.d/gnupg/
+#HookDir     = /etc/pacman.d/hooks/
+HoldPkg     = pacman glibc
+#XferCommand = /usr/bin/curl -L -C - -f -o %o %u
+#XferCommand = /usr/bin/wget --passive-ftp -c -O %o %u
+#CleanMethod = KeepInstalled
+Architecture = aarch64
+
+# Pacman won't upgrade packages listed in IgnorePkg and members of IgnoreGroup
+IgnorePkg   = linux-aarch64
+#IgnoreGroup =
+
+#NoUpgrade   =
+#NoExtract   =
+
+# Misc options
+#UseSyslog
+#Color
+#NoProgressBar
+CheckSpace
+#VerbosePkgLists
+#ParallelDownloads = 5
+
+# By default, pacman accepts packages signed by keys that its local keyring
+# trusts (see pacman-key and its man page), as well as unsigned packages.
+SigLevel = Never
+#SigLevel    = Required DatabaseOptional
+LocalFileSigLevel = Optional
+#RemoteFileSigLevel = Required
+
+# NOTE: You must run `pacman-key --init` before first using pacman; the local
+# keyring can then be populated with the keys of all official Arch Linux ARM
+# packagers with `pacman-key --populate archlinuxarm`.
+
+#
+# REPOSITORIES
+#   - can be defined here or included from another file
+#   - pacman will search repositories in the order defined here
+#   - local/custom mirrors can be added here or in separate files
+#   - repositories listed first will take precedence when packages
+#     have identical names, regardless of version number
+#   - URLs will have $repo replaced by the name of the current repo
+#   - URLs will have $arch replaced by the name of the architecture
+#
+# Repository entries are of the format:
+#       [repo-name]
+#       Server = ServerName
+#       Include = IncludePath
+#
+# The header [repo-name] is crucial - it must be present and
+# uncommented to enable the repo.
+#
+
+# The testing repositories are disabled by default. To enable, uncomment the
+# repo name header and Include lines. You can add preferred servers immediately
+# after the header, and they will be used before the default mirrors.
+
+# An example of a custom package repository.  See the pacman manpage for
+# tips on creating your own repositories.
+#[custom]
+#SigLevel = Optional TrustAll
+#Server = file:///home/custompkgs
+
+[core]
+Server = file:///sources/pkg/$arch/bootstrap
diff --git a/build64-initial.sh b/build64-initial.sh
index 0b3ae8a..2562e45 100755
--- a/build64-initial.sh
+++ b/build64-initial.sh
@@ -9,6 +9,7 @@ pacman -S --noconfirm base-devel nano which rust
 # remove sudo (and the base-devel meta, since it's what pulled sudo in...)
 pacman -R --noconfirm sudo base-devel
 
+systemd-machine-id-setup
 systemctl preset-all
 systemd-sysusers
 setfacl -Rnm g:wheel:rx,d:g:wheel:rx,g:adm:rx,d:g:adm:rx var/log/journal/ 2>/dev/null
diff --git a/build64-pacman.conf b/build64-pacman.conf
index a45a666..a9c833d 100644
--- a/build64-pacman.conf
+++ b/build64-pacman.conf
@@ -11,7 +11,7 @@
 # If you wish to use different paths, uncomment and update the paths.
 #RootDir     = /
 #DBPath      = /var/lib/pacman/
-CacheDir    = /sources/arm64-pkg
+CacheDir    = /tmp/arm64-pkg
 #LogFile     = /var/log/pacman.log
 #GPGDir      = /etc/pacman.d/gnupg/
 #HookDir     = /etc/pacman.d/hooks/
@@ -70,8 +70,8 @@ LocalFileSigLevel = Optional
 # repo name header and Include lines. You can add preferred servers immediately
 # after the header, and they will be used before the default mirrors.
 
-[arm64]
-Server = file:///sources/arm64-pkg
+[core]
+Server = file:///sources/pkg/$arch/core
 
 # An example of a custom package repository.  See the pacman manpage for
 # tips on creating your own repositories.
diff --git a/builder-initial.sh b/builder-initial.sh
new file mode 100755
index 0000000..16a3e7b
--- /dev/null
+++ b/builder-initial.sh
@@ -0,0 +1,23 @@
+#!/bin/bash
+/sbin/ldconfig -r .
+echo "en_US.UTF-8 UTF-8" >> /etc/locale.gen
+echo "LANG=en_US.UTF-8" > /etc/locale.conf
+locale-gen
+export LANG="en_US.UTF-8"
+systemd-machine-id-setup
+systemctl preset-all
+mkdir -p /home/builder
+chown builder:builder /home/builder
+gpasswd -a builder wheel
+passwd -d builder
+passwd -d root
+make-ca -r
+# ARMv8 to v7 hack (VM)
+if [ "$(uname -m)" = "armv8l" ]; then
+	mv /usr/bin/uname /usr/bin/uname.real
+	cat > /usr/bin/uname << "EOF"
+#!/bin/sh
+/usr/bin/uname.real "$@" | sed 's/armv8l/armv7l/'
+EOF
+	chmod +x /usr/bin/uname
+fi
diff --git a/make-bootstrap64.sh b/make-bootstrap64.sh
new file mode 100755
index 0000000..f2e8097
--- /dev/null
+++ b/make-bootstrap64.sh
@@ -0,0 +1,21 @@
+#!/bin/bash
+set -e
+BSN=bootstrap64
+BS=/$BSN
+mkdir -p $BS/var/lib/pacman
+pacman --config bs64-pacman.conf -Sy -b $BS/var/lib/pacman -r $BS
+pacman --config bs64-pacman.conf -S --noscriptlet -b $BS/var/lib/pacman -r $BS bootstrap
+mkdir -p /sources/pkg/aarch64/bootstrap
+cp bs64-pacman.conf $BS/etc/pacman.conf
+cp bootstrapper-initial.sh $BS/initial.sh
+cd $BS
+mount -t proc proc proc
+mount -t sysfs sys sys
+mount --bind /dev dev
+chmod +x ./initial.sh
+chroot . ./initial.sh
+systemd-machine-id-setup --root=$BS
+umount proc sys dev
+rm ./initial.sh
+cd -
+echo "Done."
diff --git a/make-bootstrapper.sh b/make-bootstrapper.sh
index a5d7fc0..cc9e41f 100755
--- a/make-bootstrapper.sh
+++ b/make-bootstrapper.sh
@@ -5,11 +5,9 @@ BS=/$BSN
 mkdir -p $BS/var/lib/pacman
 pacman -Sy -b $BS/var/lib/pacman -r $BS
 pacman -S --noconfirm --noscriptlet -b $BS/var/lib/pacman -r $BS bootstrap
-mkdir -p /sources/pkg-$BSN
+mkdir -p /sources/pkg/armv7h/bootstrap
 cp bootstrapper-initial.sh $BS/initial.sh
 cd $BS
-echo '[core]' >> etc/pacman.conf
-echo "Server = file:///sources/pkg-$BSN" >> etc/pacman.conf
 cp /etc/makepkg.conf etc/
 mount -t proc proc proc
 mount -t sysfs sys sys
diff --git a/make-builder.sh b/make-builder.sh
new file mode 100755
index 0000000..0444d57
--- /dev/null
+++ b/make-builder.sh
@@ -0,0 +1,74 @@
+#!/bin/bash
+set -e
+if [ "$CARCH" = "aarch64" ]; then
+BSN=buildcore64
+else
+BSN=build-core
+fi
+BS=/$BSN
+
+if [ -z "$CARCH" ]; then
+CARCH=armv7h
+export CARCH
+fi
+
+if [ -d $BS ]; then
+	echo "Will delete $BS, enter to continue"
+	read dummy
+	# Shh, just in case
+	umount $BS/dev 2>/dev/null || true
+	umount $BS/proc 2>/dev/null || true
+	umount $BS/sys 2>/dev/null || true
+	umount $BS/var/cache/pacman/pkg 2>/dev/null || true
+	umount $BS 2>/dev/null || true
+	rm -r $BS
+fi
+
+
+mkdir -p $BS/var/lib/pacman
+CFG=/tmp/BSN-pacman.conf
+cp /sources/core-pkgbuilds/pacman/pacman.conf $CFG
+sed -i $CFG -e "s|@CARCH[@]|$CARCH|g"
+cat >> $CFG << 'EOF'
+[base]
+Server = file:///sources/pkg/$arch/base
+[core]
+Server = file:///sources/pkg/$arch/core
+EOF
+
+REPO=/sources/pkg/$CARCH/base
+if [ ! -e $REPO ]; then
+	mkdir -p $REPO
+	cd $REPO
+	# We need a dummy package to run repo-add with to make a repo
+	cp ../core/iana-etc-*.pkg.* .
+	repo-add -R base.db.tar.gz *.pkg.*
+	repo-remove base.db.tar.gz iana-etc
+	rm -f iana-etc-*.pkg.*
+	# And there, so easy to make an empty repo :)
+	cd -
+fi
+# Wipe the effing cache; it can get in the way here
+yes | pacman -Scc
+pacman --config $CFG -Sy -b $BS/var/lib/pacman -r $BS
+pacman --config $CFG -S --noconfirm --noscriptlet -b $BS/var/lib/pacman -r $BS minimal core-devel
+cp /etc/pam.d/su $BS/etc/pam.d
+cp $CFG $BS/etc/pacman.conf
+cp builder-initial.sh $BS/initial.sh
+
+if [ "$CARCH" = "aarch64" ]; then
+# ARM32 clang & rustc helper scripts
+cp -a bc64-usr-a32 $BS/usr/a32
+fi
+
+cd $BS
+
+mount -t proc proc proc
+mount -t sysfs sys sys
+mount --bind /dev dev
+chmod +x ./initial.sh
+setarch $CARCH chroot . ./initial.sh
+umount proc sys dev
+rm ./initial.sh
+cd -
+echo "Done."